<?php

include_once("main.php");

if (!class_exists("AgeGate")) {
	class AgeGate extends AgeGateBase {
	
		var $actions = array();
		var $scripts = array();
		var $styles = array();
		var $enqueued_scripts = array();
		var $enqueued_styles = array();
		var $localized_scripts = array();
		var $admin_menu = array();
		
		
		function __construct() {
			$this->action = isset($_GET['action'])?$_GET['action']:'agegate';
			$this->enqueue_script('jquery');
			parent::__construct(false);
		}
		
		function init_admin() {
			$this->do_action('admin_menu'); 
			$this->do_action('admin_init');
			if (isset($this->actions['admin_print_styles-'.$this->action])) {
				$this->do_action('admin_print_styles-'.$this->action);
			}
			$this->do_action('get_header'); 
		}
		
		function admin() {
			include($this->plugin_path.'nonwp.php');
		}
		
		function render_admin_menu() {
			?>
			<ul id="adminmenu">
			<li class="wp-menu-separator"><div class="separator"></div></li>
			<?php foreach($this->admin_menu as $action=>$menu) { ?>
				<li class="wp-has-submenu wp-has-current-submenu wp-menu-open menu-top toplevel_page_agegate menu-top-first menu-top-last">
				<div class="wp-menu-image"><a href="#" onclick="return false"><img src="<?php echo $this->plugin_url ?>/wp/images/generic.png" alt=""></a></div>
				<div class="wp-menu-arrow"><div></div></div>
				<div class="wp-menu-toggle"><br></div>
				<?php if ($menu['function']) {?>
					<a href="<?php echo $this->admin_url('admin.php').'?action='.$action ?>" class="wp-has-submenu wp-has-current-submenu wp-menu-open menu-top menu-top-first menu-top-last"><?php echo $menu['menu_title'] ?></a>
				<?php } else { ?>
					<a href="#" onclick="return false"  class="wp-has-submenu wp-has-current-submenu wp-menu-open menu-top menu-top-first menu-top-last"><?php echo $menu['menu_title'] ?></a>
				<?php } ?>
				<?php if (sizeof($menu['submenu'])>0) { ?>
					<div class="wp-submenu"><div class="wp-submenu-wrap"><div class="wp-submenu-head">Age Gate</div>
					<ul>
					<?php foreach($menu['submenu'] as $subaction=>$submenu) { ?>
						<li<?php if ($subaction==$this->action) echo ' class="current"'?>>
							<a<?php if ($subaction==$this->action) echo ' class="current"'?> href="<?php echo $this->admin_url('admin.php').'?action='.$subaction ?>"><?php echo $submenu['menu_title'] ?></a>
						</li>
					<?php } ?>
					</ul>
					</div></div>
				<?php } ?>
				</li>
			<?php } ?>
			</ul>
			<?php 
		}
		
		function admin_ajax() {
			$this->do_action('wp_ajax_'.$this->action);
			$this->do_action('get_header'); 
			include($this->plugin_path.'nonwp.php');
		}
		
		function show() {
			$this->do_action('get_header'); 
			$this->head();
		}
		
		function head() {
			$stylesheets = $this->find_stylesheets();
			if ($this->has_asset($stylesheets, 'shadowbox')) echo 'shadow css<br />';
			if ($this->has_asset($stylesheets, 'jquery')) echo 'jqeury css<br />';
			if ($this->has_asset($scripts, 'shadowbox')) echo 'shadow script<br />';
			if ($this->has_asset($scripts, 'jquery')) echo 'jquery script<br />';
			echo "\n\n";
			foreach($this->enqueued_styles as $style) {
				if (!$this->has_asset($stylesheets, $style)) {
					echo "\t<link rel=\"stylesheet\" href=\"".$this->styles[$style]."\" />\n";
				}
			}
			$scripts = $this->find_scripts();
			foreach($this->enqueued_scripts as $token) {
				if (!$this->has_asset($scripts, $token)) {
					if (isset($this->localized_scripts[$token])) {
						echo "\t<script type=\"text/javascript\"><!--\n";
						echo "\t\tvar ".$this->localized_scripts[$token]['pars_name']." = {\n";
						$n=0;
						foreach($this->localized_scripts[$token]['pars'] as $p=>$v) {
							echo "\t\t\t".$p.": \"".$v."\"";
							$n++;
							if ($n<sizeof($this->localized_scripts[$token]['pars'])) echo ",";
							echo "\n";
						}
						echo "\t\t};\n";
						echo "\t--></script>\n";
					}
					echo "\t<script type=\"text/javascript\" src=\"".$this->scripts[$token]."\"></script>\n";
				}
			}
			
			$this->do_action('wp_head');
			echo "\n";
		}
		
		function find_stylesheets() {
			$pattern = '/<link([^>]+)>/i';
			$results = array();
			preg_match_all($pattern, ob_get_contents(), $tags);
			foreach($tags[1] as $atts) {
				preg_match_all('/([\w]+)\s*=\s*"([^"]*)"/', $atts, $attributes);
				$is_tag = false;
				foreach($attributes[1] as $i => $name) {
					if (($name=='rel' || $name=='REL') && ($attributes[2][$i]=='stylesheet' || $attributes[2][$i]=='STYLESHEET')) $is_tag = true;
				}
				if ($is_tag) {
					foreach($attributes[1] as $i => $name) {
						if ($name=='href'||$name=='HREF') $results[] = $attributes[2][$i];
					}
				}
			}
			return $results;
		}
		
		function find_scripts() {
			$pattern = '/<script([^>]+)>/i';
			$results = array();
			preg_match_all($pattern, ob_get_contents(), $tags);
			foreach($tags[1] as $atts) {
				preg_match_all('/([\w]+)\s*=\s*"([^"]*)"/', $atts, $attributes);
				$is_tag = false;
				foreach($attributes[1] as $i => $name) {
					if (($name=='type' || $name=='TYPE') && (strpos($attributes[2][$i],'javascript')!==false) || (strpos($attributes[2][$i],'JAVASCRIPT')!==false)) $is_tag = true;
				}
				if ($is_tag) {
					foreach($attributes[1] as $i => $name) {
						if ($name=='src'||$name=='SRC') $results[] = $attributes[2][$i];
					}
				}
			}
			return $results;
		}
		
		function has_asset(&$arr, $name) {
			if (!$arr) return false;
			foreach($arr as $n) {
				if (strpos($n, $name) != false) return true;
			}
			return false;
		}		
		
		function do_action($token) {
			call_user_func($this->actions[$token]);
		}
		
		function is_plugin_url() {
			return (dirname($_SERVER['REQUEST_URI']).'/' == $this->plugin_dir_url());
		}
		
		
		
		// WORDPRESS SIMULATION **********************************************************
		
		function plugin_dir_url($file='') {
			//$url = (isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] == 'on') ? 'https://' : 'http://';
			//$url .= $_SERVER['HTTP_HOST'];
			$url = dirname(substr(__FILE__,strlen($_SERVER['DOCUMENT_ROOT']))). '/';
			return $url;
		}
		function plugin_dir_path($file='') {
			return dirname(__FILE__).'/';
		}
		function add_action($token, $function) {
			$this->actions[$token] = $function;
		}
		function register_style($token, $url) {
			$this->styles[$token] = $url;
		}
		function register_script($token, $url, $reqs=array()) {
			$this->scripts[$token] = $url;
			foreach($reqs as $req) {
				$this->scripts_reqs[$token][] = $req;
			}
		}
		function enqueue_script($token) {
			$this->enqueued_scripts[] = $token;
		}
		function enqueue_style($token) {
			$this->enqueued_styles[] = $token;
		}
		function admin_url($url) {
			return $this->plugin_url.$url;
		}
		function add_menu_page($page_title, $menu_title, $perms, $token, $function) {
			if ($function) $this->add_action($token, $function);
			$this->admin_menu[$token] = array('menu_title'=>$menu_title, 'page_title'=>$page_title, 'perms'=>$perms, 'function'=>$function, 'submenu'=>array());
			return $token;
		}
		function add_submenu_page($page_token, $page_title, $menu_title, $perms, $token, $function) {
			if ($function) $this->add_action($token, $function);
			
			$this->admin_menu[$page_token]['submenu'][$token] = array('menu_title'=>$menu_title, 'page_title'=>$page_title, 'perms'=>$perms, 'function'=>$function);
			return $token;
		}
		function localize_script($token, $pars_name, $pars) {
			$this->localized_scripts[$token] = array('pars_name'=>$pars_name, 'pars'=>$pars);
		}
		function is_feed() {
			return false;
		}
		function remove_query_arg( $key, $query=false ) {
			if ( is_array( $key ) ) { // removing multiple keys
				foreach ( $key as $k )
					$query = add_query_arg( $k, false, $query );
				return $query;
			}
			return add_query_arg( $key, false, $query );
		}
		function add_shortcode($token, $function) {
		}
				
	}
	
	$agegate = new AgeGate(false);
	
}